--[[ Copyright (c) 2020 Picklock
 * Part of Picklock's rocket silo stats
 * settings.lua
 * Version 1.0.0.10
 *
 * See LICENSE.MD in the project directory for license information.
--]]

data:extend{
    -- map settings
    {
        type = 'bool-setting',
        name = 'pi-rss-show-heading',
        setting_type = 'runtime-global',
        default_value = true,
        order = 'a',
    },
	{
		type = "string-setting",
		name = "pi-rss-show-in-stats",
		setting_type = "runtime-global",
		default_value = "Rocket launches and payload",
		allowed_values = { "Rocket launches and payload", "Rocket launches only", "Payload only"},
		order = "b",
	},
	{
		type = "string-setting",
		name = "pi-rss-track-items",
		setting_type = "runtime-global",
		default_value = "satellite",
		allowed_values = { "all", "satellite", "satellite and fisch", "filter-lists"},
		order = "c",
	},
    {
        type = 'string-setting',
        name = 'pi-rss-whitelist',
        setting_type = 'runtime-global',
        default_value = '',
        allow_blank = true,
        order = 'd',
    },
    {
        type = 'string-setting',
        name = 'pi-rss-blacklist',
        setting_type = 'runtime-global',
        default_value = '',
        allow_blank = true,
        order = 'e',
    },
    {
        type = 'bool-setting',
        name = 'pi-rss-show-average',
        setting_type = 'runtime-global',
        default_value = false,
        order = 'f',
    },
	{
		type = "string-setting",
		name = "pi-rss-average-per",
		setting_type = "runtime-global",
		default_value = "1 hour",
		allowed_values = { "1 minute", "10 minutes", "30 minutes", "1 hour", "5 hours", "10 hours"},
		order = "g",
	},
    -- player settings
    {
        type = 'bool-setting',
        name = 'pi-rss-show-tb',
        setting_type = 'runtime-per-user',
        default_value = true,
        order = 'a',
    },
    {
        type = 'bool-setting',
        name = 'pi-rss-hide-empty',
        setting_type = 'runtime-per-user',
        default_value = true,
        order = 'b',
    },
}