-------------------------------------------------------------------------------
--FACTORIO MOD: Fluid Void Extra
--A mod, redesigned from Rseding91's Fluid Void Mod, to work properly for newer versions.
--Author: Nibuja05
--Date: 15.1.2019
-------------------------------------------------------------------------------

local pipeSpeed = {200, 100, 50, 25, 10, 5, 1}

script.on_event(defines.events.on_built_entity,
	function (event)
		savePipe(event.created_entity)	
	end
)

script.on_event(defines.events.on_robot_built_entity,
	function (event)
		savePipe(event.created_entity)	
	end
)

script.on_event({defines.events.on_tick},
	function(event)
		processPipes(event)
	end
)

function savePipe(entity)
	if entity.name == "void-pipe" then
		if global.pipes == nil then
			global.pipes = {}
		end
		if not global.pipes.speedClass then
			global.pipes.speedClass = {}
		end
		if not global.pipes.speedClass[1] then
			global.pipes.speedClass[1] = {}
		end
		table.insert(global.pipes.speedClass[1], entity)
	end
end

function processPipes(event)
	local tick = event.tick
	local speedMultiplier = settings.global["fluid-void-extra-speedmultiplier"].value
	for k,speed in pairs(pipeSpeed) do
		if tick % (speed / speedMultiplier) == 0 then
			if global.pipes == nil then
				return
			end
			if not global.pipes.speedClass then
				global.pipes.speedClass = {}
			end
			if not global.pipes.speedClass[k] then
				global.pipes.speedClass[k] = {}
			end
			processPipesWithSpeed(k)
		end
	end
end

function processPipesWithSpeed(speed)
	if global.pipes ~= nil then
		for k, pipe in pairs(global.pipes.speedClass[speed]) do
			if pipe.valid then
				if pipe.fluidbox[1] then
					local amount = pipe.fluidbox[1].amount
					pipe.fluidbox[1] = nil
					if amount > 80 and speed < #pipeSpeed then
						table.remove(global.pipes.speedClass[speed], k)
						if not global.pipes.speedClass[speed + 1] then
							global.pipes.speedClass[speed + 1] = {}
						end
						table.insert(global.pipes.speedClass[speed + 1], pipe)
					elseif amount < 30 and speed > 1 then
						table.remove(global.pipes.speedClass[speed], k)
						if not global.pipes.speedClass[speed - 1] then
							global.pipes.speedClass[speed - 1] = {}
						end
						table.insert(global.pipes.speedClass[speed - 1], pipe)
					end
				end
			else
				table.remove(global.pipes.speedClass[speed], k)
				if #global.pipes.speedClass[speed] == 0 then
					global.pipes.speedClass[speed] = nil
				end
			end
		end
	end
end